<?php
/**
 * Order
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * OMS
 *
 * Управление заказами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\OmsClient\Dto;

use \ArrayAccess;
use \Ensi\OmsClient\ObjectSerializer;

/**
 * Order Class Doc Comment
 *
 * @category Class
 * @package  Ensi\OmsClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Order implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Order';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'number' => 'string',
        'customer_id' => 'int',
        'customer_email' => 'string',
        'cost' => 'int',
        'price' => 'int',
        'spent_bonus' => 'int',
        'added_bonus' => 'int',
        'promo_code' => 'string',
        'status_at' => '\DateTime',
        'source' => 'int',
        'payment_status' => 'int',
        'payment_status_at' => '\DateTime',
        'payed_at' => '\DateTime',
        'payed_price' => 'int',
        'payment_expires_at' => '\DateTime',
        'payment_method' => 'int',
        'payment_system' => 'int',
        'payment_link' => 'string',
        'payment_external_id' => 'string',
        'payment_data' => '\Ensi\OmsClient\Dto\OrderPaymentData',
        'is_problem_at' => '\DateTime',
        'is_editable' => 'bool',
        'is_changed' => 'bool',
        'is_expired' => 'bool',
        'is_expired_at' => '\DateTime',
        'is_return' => 'bool',
        'is_return_at' => '\DateTime',
        'is_partial_return' => 'bool',
        'is_partial_return_at' => '\DateTime',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'responsible_id' => 'int',
        'status' => 'int',
        'client_comment' => 'string',
        'receiver_name' => 'string',
        'receiver_phone' => 'string',
        'receiver_email' => 'string',
        'is_problem' => 'bool',
        'problem_comment' => 'string',
        'delivery_service' => 'int',
        'delivery_method' => 'int',
        'delivery_cost' => 'int',
        'delivery_price' => 'int',
        'delivery_point_id' => 'int',
        'delivery_address' => '\Ensi\OmsClient\Dto\Address',
        'delivery_comment' => 'string',
        'items' => '\Ensi\OmsClient\Dto\OrderItem[]',
        'deliveries' => '\Ensi\OmsClient\Dto\Delivery[]',
        'files' => '\Ensi\OmsClient\Dto\OrderFile[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'number' => null,
        'customer_id' => null,
        'customer_email' => null,
        'cost' => null,
        'price' => null,
        'spent_bonus' => null,
        'added_bonus' => null,
        'promo_code' => null,
        'status_at' => 'date-time',
        'source' => null,
        'payment_status' => null,
        'payment_status_at' => 'date-time',
        'payed_at' => 'date-time',
        'payed_price' => null,
        'payment_expires_at' => 'date-time',
        'payment_method' => null,
        'payment_system' => null,
        'payment_link' => null,
        'payment_external_id' => null,
        'payment_data' => null,
        'is_problem_at' => 'date-time',
        'is_editable' => null,
        'is_changed' => null,
        'is_expired' => null,
        'is_expired_at' => 'date-time',
        'is_return' => null,
        'is_return_at' => 'date-time',
        'is_partial_return' => null,
        'is_partial_return_at' => 'date-time',
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'responsible_id' => null,
        'status' => null,
        'client_comment' => null,
        'receiver_name' => null,
        'receiver_phone' => null,
        'receiver_email' => null,
        'is_problem' => null,
        'problem_comment' => null,
        'delivery_service' => null,
        'delivery_method' => null,
        'delivery_cost' => null,
        'delivery_price' => null,
        'delivery_point_id' => null,
        'delivery_address' => null,
        'delivery_comment' => null,
        'items' => null,
        'deliveries' => null,
        'files' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'number' => false,
        'customer_id' => false,
        'customer_email' => false,
        'cost' => false,
        'price' => false,
        'spent_bonus' => false,
        'added_bonus' => false,
        'promo_code' => true,
        'status_at' => false,
        'source' => false,
        'payment_status' => false,
        'payment_status_at' => false,
        'payed_at' => true,
        'payed_price' => true,
        'payment_expires_at' => true,
        'payment_method' => false,
        'payment_system' => false,
        'payment_link' => true,
        'payment_external_id' => true,
        'payment_data' => false,
        'is_problem_at' => true,
        'is_editable' => false,
        'is_changed' => false,
        'is_expired' => false,
        'is_expired_at' => true,
        'is_return' => false,
        'is_return_at' => true,
        'is_partial_return' => false,
        'is_partial_return_at' => true,
        'created_at' => false,
        'updated_at' => false,
        'responsible_id' => true,
        'status' => false,
        'client_comment' => true,
        'receiver_name' => true,
        'receiver_phone' => true,
        'receiver_email' => true,
        'is_problem' => true,
        'problem_comment' => true,
        'delivery_service' => false,
        'delivery_method' => false,
        'delivery_cost' => false,
        'delivery_price' => false,
        'delivery_point_id' => true,
        'delivery_address' => true,
        'delivery_comment' => true,
        'items' => false,
        'deliveries' => false,
        'files' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'number' => 'number',
        'customer_id' => 'customer_id',
        'customer_email' => 'customer_email',
        'cost' => 'cost',
        'price' => 'price',
        'spent_bonus' => 'spent_bonus',
        'added_bonus' => 'added_bonus',
        'promo_code' => 'promo_code',
        'status_at' => 'status_at',
        'source' => 'source',
        'payment_status' => 'payment_status',
        'payment_status_at' => 'payment_status_at',
        'payed_at' => 'payed_at',
        'payed_price' => 'payed_price',
        'payment_expires_at' => 'payment_expires_at',
        'payment_method' => 'payment_method',
        'payment_system' => 'payment_system',
        'payment_link' => 'payment_link',
        'payment_external_id' => 'payment_external_id',
        'payment_data' => 'payment_data',
        'is_problem_at' => 'is_problem_at',
        'is_editable' => 'is_editable',
        'is_changed' => 'is_changed',
        'is_expired' => 'is_expired',
        'is_expired_at' => 'is_expired_at',
        'is_return' => 'is_return',
        'is_return_at' => 'is_return_at',
        'is_partial_return' => 'is_partial_return',
        'is_partial_return_at' => 'is_partial_return_at',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'responsible_id' => 'responsible_id',
        'status' => 'status',
        'client_comment' => 'client_comment',
        'receiver_name' => 'receiver_name',
        'receiver_phone' => 'receiver_phone',
        'receiver_email' => 'receiver_email',
        'is_problem' => 'is_problem',
        'problem_comment' => 'problem_comment',
        'delivery_service' => 'delivery_service',
        'delivery_method' => 'delivery_method',
        'delivery_cost' => 'delivery_cost',
        'delivery_price' => 'delivery_price',
        'delivery_point_id' => 'delivery_point_id',
        'delivery_address' => 'delivery_address',
        'delivery_comment' => 'delivery_comment',
        'items' => 'items',
        'deliveries' => 'deliveries',
        'files' => 'files'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'number' => 'setNumber',
        'customer_id' => 'setCustomerId',
        'customer_email' => 'setCustomerEmail',
        'cost' => 'setCost',
        'price' => 'setPrice',
        'spent_bonus' => 'setSpentBonus',
        'added_bonus' => 'setAddedBonus',
        'promo_code' => 'setPromoCode',
        'status_at' => 'setStatusAt',
        'source' => 'setSource',
        'payment_status' => 'setPaymentStatus',
        'payment_status_at' => 'setPaymentStatusAt',
        'payed_at' => 'setPayedAt',
        'payed_price' => 'setPayedPrice',
        'payment_expires_at' => 'setPaymentExpiresAt',
        'payment_method' => 'setPaymentMethod',
        'payment_system' => 'setPaymentSystem',
        'payment_link' => 'setPaymentLink',
        'payment_external_id' => 'setPaymentExternalId',
        'payment_data' => 'setPaymentData',
        'is_problem_at' => 'setIsProblemAt',
        'is_editable' => 'setIsEditable',
        'is_changed' => 'setIsChanged',
        'is_expired' => 'setIsExpired',
        'is_expired_at' => 'setIsExpiredAt',
        'is_return' => 'setIsReturn',
        'is_return_at' => 'setIsReturnAt',
        'is_partial_return' => 'setIsPartialReturn',
        'is_partial_return_at' => 'setIsPartialReturnAt',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'responsible_id' => 'setResponsibleId',
        'status' => 'setStatus',
        'client_comment' => 'setClientComment',
        'receiver_name' => 'setReceiverName',
        'receiver_phone' => 'setReceiverPhone',
        'receiver_email' => 'setReceiverEmail',
        'is_problem' => 'setIsProblem',
        'problem_comment' => 'setProblemComment',
        'delivery_service' => 'setDeliveryService',
        'delivery_method' => 'setDeliveryMethod',
        'delivery_cost' => 'setDeliveryCost',
        'delivery_price' => 'setDeliveryPrice',
        'delivery_point_id' => 'setDeliveryPointId',
        'delivery_address' => 'setDeliveryAddress',
        'delivery_comment' => 'setDeliveryComment',
        'items' => 'setItems',
        'deliveries' => 'setDeliveries',
        'files' => 'setFiles'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'number' => 'getNumber',
        'customer_id' => 'getCustomerId',
        'customer_email' => 'getCustomerEmail',
        'cost' => 'getCost',
        'price' => 'getPrice',
        'spent_bonus' => 'getSpentBonus',
        'added_bonus' => 'getAddedBonus',
        'promo_code' => 'getPromoCode',
        'status_at' => 'getStatusAt',
        'source' => 'getSource',
        'payment_status' => 'getPaymentStatus',
        'payment_status_at' => 'getPaymentStatusAt',
        'payed_at' => 'getPayedAt',
        'payed_price' => 'getPayedPrice',
        'payment_expires_at' => 'getPaymentExpiresAt',
        'payment_method' => 'getPaymentMethod',
        'payment_system' => 'getPaymentSystem',
        'payment_link' => 'getPaymentLink',
        'payment_external_id' => 'getPaymentExternalId',
        'payment_data' => 'getPaymentData',
        'is_problem_at' => 'getIsProblemAt',
        'is_editable' => 'getIsEditable',
        'is_changed' => 'getIsChanged',
        'is_expired' => 'getIsExpired',
        'is_expired_at' => 'getIsExpiredAt',
        'is_return' => 'getIsReturn',
        'is_return_at' => 'getIsReturnAt',
        'is_partial_return' => 'getIsPartialReturn',
        'is_partial_return_at' => 'getIsPartialReturnAt',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'responsible_id' => 'getResponsibleId',
        'status' => 'getStatus',
        'client_comment' => 'getClientComment',
        'receiver_name' => 'getReceiverName',
        'receiver_phone' => 'getReceiverPhone',
        'receiver_email' => 'getReceiverEmail',
        'is_problem' => 'getIsProblem',
        'problem_comment' => 'getProblemComment',
        'delivery_service' => 'getDeliveryService',
        'delivery_method' => 'getDeliveryMethod',
        'delivery_cost' => 'getDeliveryCost',
        'delivery_price' => 'getDeliveryPrice',
        'delivery_point_id' => 'getDeliveryPointId',
        'delivery_address' => 'getDeliveryAddress',
        'delivery_comment' => 'getDeliveryComment',
        'items' => 'getItems',
        'deliveries' => 'getDeliveries',
        'files' => 'getFiles'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('number', $data, null);
        $this->setIfExists('customer_id', $data, null);
        $this->setIfExists('customer_email', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('spent_bonus', $data, null);
        $this->setIfExists('added_bonus', $data, null);
        $this->setIfExists('promo_code', $data, null);
        $this->setIfExists('status_at', $data, null);
        $this->setIfExists('source', $data, null);
        $this->setIfExists('payment_status', $data, null);
        $this->setIfExists('payment_status_at', $data, null);
        $this->setIfExists('payed_at', $data, null);
        $this->setIfExists('payed_price', $data, null);
        $this->setIfExists('payment_expires_at', $data, null);
        $this->setIfExists('payment_method', $data, null);
        $this->setIfExists('payment_system', $data, null);
        $this->setIfExists('payment_link', $data, null);
        $this->setIfExists('payment_external_id', $data, null);
        $this->setIfExists('payment_data', $data, null);
        $this->setIfExists('is_problem_at', $data, null);
        $this->setIfExists('is_editable', $data, null);
        $this->setIfExists('is_changed', $data, null);
        $this->setIfExists('is_expired', $data, null);
        $this->setIfExists('is_expired_at', $data, null);
        $this->setIfExists('is_return', $data, null);
        $this->setIfExists('is_return_at', $data, null);
        $this->setIfExists('is_partial_return', $data, null);
        $this->setIfExists('is_partial_return_at', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('responsible_id', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('client_comment', $data, null);
        $this->setIfExists('receiver_name', $data, null);
        $this->setIfExists('receiver_phone', $data, null);
        $this->setIfExists('receiver_email', $data, null);
        $this->setIfExists('is_problem', $data, null);
        $this->setIfExists('problem_comment', $data, null);
        $this->setIfExists('delivery_service', $data, null);
        $this->setIfExists('delivery_method', $data, null);
        $this->setIfExists('delivery_cost', $data, null);
        $this->setIfExists('delivery_price', $data, null);
        $this->setIfExists('delivery_point_id', $data, null);
        $this->setIfExists('delivery_address', $data, null);
        $this->setIfExists('delivery_comment', $data, null);
        $this->setIfExists('items', $data, null);
        $this->setIfExists('deliveries', $data, null);
        $this->setIfExists('files', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['number'] === null) {
            $invalidProperties[] = "'number' can't be null";
        }
        if ($this->container['customer_id'] === null) {
            $invalidProperties[] = "'customer_id' can't be null";
        }
        if ($this->container['customer_email'] === null) {
            $invalidProperties[] = "'customer_email' can't be null";
        }
        if ($this->container['cost'] === null) {
            $invalidProperties[] = "'cost' can't be null";
        }
        if ($this->container['price'] === null) {
            $invalidProperties[] = "'price' can't be null";
        }
        if ($this->container['spent_bonus'] === null) {
            $invalidProperties[] = "'spent_bonus' can't be null";
        }
        if ($this->container['added_bonus'] === null) {
            $invalidProperties[] = "'added_bonus' can't be null";
        }
        if ($this->container['promo_code'] === null) {
            $invalidProperties[] = "'promo_code' can't be null";
        }
        if ($this->container['status_at'] === null) {
            $invalidProperties[] = "'status_at' can't be null";
        }
        if ($this->container['source'] === null) {
            $invalidProperties[] = "'source' can't be null";
        }
        if ($this->container['payment_status'] === null) {
            $invalidProperties[] = "'payment_status' can't be null";
        }
        if ($this->container['payment_status_at'] === null) {
            $invalidProperties[] = "'payment_status_at' can't be null";
        }
        if ($this->container['payed_at'] === null) {
            $invalidProperties[] = "'payed_at' can't be null";
        }
        if ($this->container['payed_price'] === null) {
            $invalidProperties[] = "'payed_price' can't be null";
        }
        if ($this->container['payment_expires_at'] === null) {
            $invalidProperties[] = "'payment_expires_at' can't be null";
        }
        if ($this->container['payment_method'] === null) {
            $invalidProperties[] = "'payment_method' can't be null";
        }
        if ($this->container['payment_system'] === null) {
            $invalidProperties[] = "'payment_system' can't be null";
        }
        if ($this->container['payment_link'] === null) {
            $invalidProperties[] = "'payment_link' can't be null";
        }
        if ($this->container['payment_external_id'] === null) {
            $invalidProperties[] = "'payment_external_id' can't be null";
        }
        if ($this->container['payment_data'] === null) {
            $invalidProperties[] = "'payment_data' can't be null";
        }
        if ($this->container['is_problem_at'] === null) {
            $invalidProperties[] = "'is_problem_at' can't be null";
        }
        if ($this->container['is_expired'] === null) {
            $invalidProperties[] = "'is_expired' can't be null";
        }
        if ($this->container['is_expired_at'] === null) {
            $invalidProperties[] = "'is_expired_at' can't be null";
        }
        if ($this->container['is_return'] === null) {
            $invalidProperties[] = "'is_return' can't be null";
        }
        if ($this->container['is_return_at'] === null) {
            $invalidProperties[] = "'is_return_at' can't be null";
        }
        if ($this->container['is_partial_return'] === null) {
            $invalidProperties[] = "'is_partial_return' can't be null";
        }
        if ($this->container['is_partial_return_at'] === null) {
            $invalidProperties[] = "'is_partial_return_at' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id ID заказа
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets number
     *
     * @return string
     */
    public function getNumber()
    {
        return $this->container['number'];
    }

    /**
     * Sets number
     *
     * @param string $number номер заказа
     *
     * @return $this
     */
    public function setNumber($number)
    {


        /*if (is_null($number)) {
            throw new \InvalidArgumentException('non-nullable number cannot be null');
        }*/
        $this->container['number'] = $number;

        return $this;
    }

    /**
     * Gets customer_id
     *
     * @return int
     */
    public function getCustomerId()
    {
        return $this->container['customer_id'];
    }

    /**
     * Sets customer_id
     *
     * @param int $customer_id id покупателя
     *
     * @return $this
     */
    public function setCustomerId($customer_id)
    {


        /*if (is_null($customer_id)) {
            throw new \InvalidArgumentException('non-nullable customer_id cannot be null');
        }*/
        $this->container['customer_id'] = $customer_id;

        return $this;
    }

    /**
     * Gets customer_email
     *
     * @return string
     */
    public function getCustomerEmail()
    {
        return $this->container['customer_email'];
    }

    /**
     * Sets customer_email
     *
     * @param string $customer_email почта покупателя
     *
     * @return $this
     */
    public function setCustomerEmail($customer_email)
    {


        /*if (is_null($customer_email)) {
            throw new \InvalidArgumentException('non-nullable customer_email cannot be null');
        }*/
        $this->container['customer_email'] = $customer_email;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int $cost стоимость (без учета скидки) (рассчитывается автоматически) в коп.
     *
     * @return $this
     */
    public function setCost($cost)
    {


        /*if (is_null($cost)) {
            throw new \InvalidArgumentException('non-nullable cost cannot be null');
        }*/
        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int $price стоимость (с учетом скидок) (рассчитывается автоматически) в коп.
     *
     * @return $this
     */
    public function setPrice($price)
    {


        /*if (is_null($price)) {
            throw new \InvalidArgumentException('non-nullable price cannot be null');
        }*/
        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets spent_bonus
     *
     * @return int
     */
    public function getSpentBonus()
    {
        return $this->container['spent_bonus'];
    }

    /**
     * Sets spent_bonus
     *
     * @param int $spent_bonus списано бонусов
     *
     * @return $this
     */
    public function setSpentBonus($spent_bonus)
    {


        /*if (is_null($spent_bonus)) {
            throw new \InvalidArgumentException('non-nullable spent_bonus cannot be null');
        }*/
        $this->container['spent_bonus'] = $spent_bonus;

        return $this;
    }

    /**
     * Gets added_bonus
     *
     * @return int
     */
    public function getAddedBonus()
    {
        return $this->container['added_bonus'];
    }

    /**
     * Sets added_bonus
     *
     * @param int $added_bonus начислено бонусов
     *
     * @return $this
     */
    public function setAddedBonus($added_bonus)
    {


        /*if (is_null($added_bonus)) {
            throw new \InvalidArgumentException('non-nullable added_bonus cannot be null');
        }*/
        $this->container['added_bonus'] = $added_bonus;

        return $this;
    }

    /**
     * Gets promo_code
     *
     * @return string|null
     */
    public function getPromoCode()
    {
        return $this->container['promo_code'];
    }

    /**
     * Sets promo_code
     *
     * @param string|null $promo_code Использованный промокод
     *
     * @return $this
     */
    public function setPromoCode($promo_code)
    {

        if (is_null($promo_code)) {
            array_push($this->openAPINullablesSetToNull, 'promo_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('promo_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['promo_code'] = $promo_code;

        return $this;
    }

    /**
     * Gets status_at
     *
     * @return \DateTime
     */
    public function getStatusAt()
    {
        return $this->container['status_at'];
    }

    /**
     * Sets status_at
     *
     * @param \DateTime $status_at дата установки статуса заказа
     *
     * @return $this
     */
    public function setStatusAt($status_at)
    {


        /*if (is_null($status_at)) {
            throw new \InvalidArgumentException('non-nullable status_at cannot be null');
        }*/
        $this->container['status_at'] = $status_at;

        return $this;
    }

    /**
     * Gets source
     *
     * @return int
     */
    public function getSource()
    {
        return $this->container['source'];
    }

    /**
     * Sets source
     *
     * @param int $source источник заказа из OrderSourceEnum
     *
     * @return $this
     */
    public function setSource($source)
    {


        /*if (is_null($source)) {
            throw new \InvalidArgumentException('non-nullable source cannot be null');
        }*/
        $this->container['source'] = $source;

        return $this;
    }

    /**
     * Gets payment_status
     *
     * @return int
     */
    public function getPaymentStatus()
    {
        return $this->container['payment_status'];
    }

    /**
     * Sets payment_status
     *
     * @param int $payment_status статус оплаты из PaymentStatusEnum
     *
     * @return $this
     */
    public function setPaymentStatus($payment_status)
    {


        /*if (is_null($payment_status)) {
            throw new \InvalidArgumentException('non-nullable payment_status cannot be null');
        }*/
        $this->container['payment_status'] = $payment_status;

        return $this;
    }

    /**
     * Gets payment_status_at
     *
     * @return \DateTime
     */
    public function getPaymentStatusAt()
    {
        return $this->container['payment_status_at'];
    }

    /**
     * Sets payment_status_at
     *
     * @param \DateTime $payment_status_at дата установки статуса оплаты
     *
     * @return $this
     */
    public function setPaymentStatusAt($payment_status_at)
    {


        /*if (is_null($payment_status_at)) {
            throw new \InvalidArgumentException('non-nullable payment_status_at cannot be null');
        }*/
        $this->container['payment_status_at'] = $payment_status_at;

        return $this;
    }

    /**
     * Gets payed_at
     *
     * @return \DateTime|null
     */
    public function getPayedAt()
    {
        return $this->container['payed_at'];
    }

    /**
     * Sets payed_at
     *
     * @param \DateTime|null $payed_at Дата оплаты
     *
     * @return $this
     */
    public function setPayedAt($payed_at)
    {

        if (is_null($payed_at)) {
            array_push($this->openAPINullablesSetToNull, 'payed_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payed_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payed_at'] = $payed_at;

        return $this;
    }

    /**
     * Gets payed_price
     *
     * @return int|null
     */
    public function getPayedPrice()
    {
        return $this->container['payed_price'];
    }

    /**
     * Sets payed_price
     *
     * @param int|null $payed_price Сумма оплаты
     *
     * @return $this
     */
    public function setPayedPrice($payed_price)
    {

        if (is_null($payed_price)) {
            array_push($this->openAPINullablesSetToNull, 'payed_price');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payed_price', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payed_price'] = $payed_price;

        return $this;
    }

    /**
     * Gets payment_expires_at
     *
     * @return \DateTime|null
     */
    public function getPaymentExpiresAt()
    {
        return $this->container['payment_expires_at'];
    }

    /**
     * Sets payment_expires_at
     *
     * @param \DateTime|null $payment_expires_at Дата, до которой нужно провести оплату
     *
     * @return $this
     */
    public function setPaymentExpiresAt($payment_expires_at)
    {

        if (is_null($payment_expires_at)) {
            array_push($this->openAPINullablesSetToNull, 'payment_expires_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_expires_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_expires_at'] = $payment_expires_at;

        return $this;
    }

    /**
     * Gets payment_method
     *
     * @return int
     */
    public function getPaymentMethod()
    {
        return $this->container['payment_method'];
    }

    /**
     * Sets payment_method
     *
     * @param int $payment_method метод оплаты из PaymentMethodEnum
     *
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {


        /*if (is_null($payment_method)) {
            throw new \InvalidArgumentException('non-nullable payment_method cannot be null');
        }*/
        $this->container['payment_method'] = $payment_method;

        return $this;
    }

    /**
     * Gets payment_system
     *
     * @return int
     */
    public function getPaymentSystem()
    {
        return $this->container['payment_system'];
    }

    /**
     * Sets payment_system
     *
     * @param int $payment_system payment_system
     *
     * @return $this
     */
    public function setPaymentSystem($payment_system)
    {


        /*if (is_null($payment_system)) {
            throw new \InvalidArgumentException('non-nullable payment_system cannot be null');
        }*/
        $this->container['payment_system'] = $payment_system;

        return $this;
    }

    /**
     * Gets payment_link
     *
     * @return string|null
     */
    public function getPaymentLink()
    {
        return $this->container['payment_link'];
    }

    /**
     * Sets payment_link
     *
     * @param string|null $payment_link Ссылка для оплаты во внещней системе
     *
     * @return $this
     */
    public function setPaymentLink($payment_link)
    {

        if (is_null($payment_link)) {
            array_push($this->openAPINullablesSetToNull, 'payment_link');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_link', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_link'] = $payment_link;

        return $this;
    }

    /**
     * Gets payment_external_id
     *
     * @return string|null
     */
    public function getPaymentExternalId()
    {
        return $this->container['payment_external_id'];
    }

    /**
     * Sets payment_external_id
     *
     * @param string|null $payment_external_id ID оплаты во внешней системе
     *
     * @return $this
     */
    public function setPaymentExternalId($payment_external_id)
    {

        if (is_null($payment_external_id)) {
            array_push($this->openAPINullablesSetToNull, 'payment_external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('payment_external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['payment_external_id'] = $payment_external_id;

        return $this;
    }

    /**
     * Gets payment_data
     *
     * @return \Ensi\OmsClient\Dto\OrderPaymentData
     */
    public function getPaymentData()
    {
        return $this->container['payment_data'];
    }

    /**
     * Sets payment_data
     *
     * @param \Ensi\OmsClient\Dto\OrderPaymentData $payment_data payment_data
     *
     * @return $this
     */
    public function setPaymentData($payment_data)
    {


        /*if (is_null($payment_data)) {
            throw new \InvalidArgumentException('non-nullable payment_data cannot be null');
        }*/
        $this->container['payment_data'] = $payment_data;

        return $this;
    }

    /**
     * Gets is_problem_at
     *
     * @return \DateTime|null
     */
    public function getIsProblemAt()
    {
        return $this->container['is_problem_at'];
    }

    /**
     * Sets is_problem_at
     *
     * @param \DateTime|null $is_problem_at дата установки флага проблемного заказа
     *
     * @return $this
     */
    public function setIsProblemAt($is_problem_at)
    {

        if (is_null($is_problem_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_problem_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_problem_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_problem_at'] = $is_problem_at;

        return $this;
    }

    /**
     * Gets is_editable
     *
     * @return bool|null
     */
    public function getIsEditable()
    {
        return $this->container['is_editable'];
    }

    /**
     * Sets is_editable
     *
     * @param bool|null $is_editable флаг, что заказ может быть изменён
     *
     * @return $this
     */
    public function setIsEditable($is_editable)
    {


        /*if (is_null($is_editable)) {
            throw new \InvalidArgumentException('non-nullable is_editable cannot be null');
        }*/
        $this->container['is_editable'] = $is_editable;

        return $this;
    }

    /**
     * Gets is_changed
     *
     * @return bool|null
     */
    public function getIsChanged()
    {
        return $this->container['is_changed'];
    }

    /**
     * Sets is_changed
     *
     * @param bool|null $is_changed флаг, что заказ был изменён
     *
     * @return $this
     */
    public function setIsChanged($is_changed)
    {


        /*if (is_null($is_changed)) {
            throw new \InvalidArgumentException('non-nullable is_changed cannot be null');
        }*/
        $this->container['is_changed'] = $is_changed;

        return $this;
    }

    /**
     * Gets is_expired
     *
     * @return bool
     */
    public function getIsExpired()
    {
        return $this->container['is_expired'];
    }

    /**
     * Sets is_expired
     *
     * @param bool $is_expired флаг, что заказ просроченный
     *
     * @return $this
     */
    public function setIsExpired($is_expired)
    {


        /*if (is_null($is_expired)) {
            throw new \InvalidArgumentException('non-nullable is_expired cannot be null');
        }*/
        $this->container['is_expired'] = $is_expired;

        return $this;
    }

    /**
     * Gets is_expired_at
     *
     * @return \DateTime|null
     */
    public function getIsExpiredAt()
    {
        return $this->container['is_expired_at'];
    }

    /**
     * Sets is_expired_at
     *
     * @param \DateTime|null $is_expired_at дата установки флага просроченного заказа
     *
     * @return $this
     */
    public function setIsExpiredAt($is_expired_at)
    {

        if (is_null($is_expired_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_expired_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_expired_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_expired_at'] = $is_expired_at;

        return $this;
    }

    /**
     * Gets is_return
     *
     * @return bool
     */
    public function getIsReturn()
    {
        return $this->container['is_return'];
    }

    /**
     * Sets is_return
     *
     * @param bool $is_return флаг, что заказ возвращен
     *
     * @return $this
     */
    public function setIsReturn($is_return)
    {


        /*if (is_null($is_return)) {
            throw new \InvalidArgumentException('non-nullable is_return cannot be null');
        }*/
        $this->container['is_return'] = $is_return;

        return $this;
    }

    /**
     * Gets is_return_at
     *
     * @return \DateTime|null
     */
    public function getIsReturnAt()
    {
        return $this->container['is_return_at'];
    }

    /**
     * Sets is_return_at
     *
     * @param \DateTime|null $is_return_at дата установки флага возвращенного заказа
     *
     * @return $this
     */
    public function setIsReturnAt($is_return_at)
    {

        if (is_null($is_return_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_return_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_return_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_return_at'] = $is_return_at;

        return $this;
    }

    /**
     * Gets is_partial_return
     *
     * @return bool
     */
    public function getIsPartialReturn()
    {
        return $this->container['is_partial_return'];
    }

    /**
     * Sets is_partial_return
     *
     * @param bool $is_partial_return флаг, что заказ частично возвращен
     *
     * @return $this
     */
    public function setIsPartialReturn($is_partial_return)
    {


        /*if (is_null($is_partial_return)) {
            throw new \InvalidArgumentException('non-nullable is_partial_return cannot be null');
        }*/
        $this->container['is_partial_return'] = $is_partial_return;

        return $this;
    }

    /**
     * Gets is_partial_return_at
     *
     * @return \DateTime|null
     */
    public function getIsPartialReturnAt()
    {
        return $this->container['is_partial_return_at'];
    }

    /**
     * Sets is_partial_return_at
     *
     * @param \DateTime|null $is_partial_return_at дата установки флага частично возвращенного заказа
     *
     * @return $this
     */
    public function setIsPartialReturnAt($is_partial_return_at)
    {

        if (is_null($is_partial_return_at)) {
            array_push($this->openAPINullablesSetToNull, 'is_partial_return_at');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_partial_return_at', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_partial_return_at'] = $is_partial_return_at;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at дата создания заказа
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at дата обновления заказа
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets responsible_id
     *
     * @return int|null
     */
    public function getResponsibleId()
    {
        return $this->container['responsible_id'];
    }

    /**
     * Sets responsible_id
     *
     * @param int|null $responsible_id Идентификатор ответственного за заказ
     *
     * @return $this
     */
    public function setResponsibleId($responsible_id)
    {

        if (is_null($responsible_id)) {
            array_push($this->openAPINullablesSetToNull, 'responsible_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('responsible_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['responsible_id'] = $responsible_id;

        return $this;
    }

    /**
     * Gets status
     *
     * @return int|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param int|null $status статус заказа из OrderStatus
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets client_comment
     *
     * @return string|null
     */
    public function getClientComment()
    {
        return $this->container['client_comment'];
    }

    /**
     * Sets client_comment
     *
     * @param string|null $client_comment комментарий клиента
     *
     * @return $this
     */
    public function setClientComment($client_comment)
    {

        if (is_null($client_comment)) {
            array_push($this->openAPINullablesSetToNull, 'client_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('client_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['client_comment'] = $client_comment;

        return $this;
    }

    /**
     * Gets receiver_name
     *
     * @return string|null
     */
    public function getReceiverName()
    {
        return $this->container['receiver_name'];
    }

    /**
     * Sets receiver_name
     *
     * @param string|null $receiver_name имя получателя
     *
     * @return $this
     */
    public function setReceiverName($receiver_name)
    {

        if (is_null($receiver_name)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_name'] = $receiver_name;

        return $this;
    }

    /**
     * Gets receiver_phone
     *
     * @return string|null
     */
    public function getReceiverPhone()
    {
        return $this->container['receiver_phone'];
    }

    /**
     * Sets receiver_phone
     *
     * @param string|null $receiver_phone телефон получателя
     *
     * @return $this
     */
    public function setReceiverPhone($receiver_phone)
    {

        if (is_null($receiver_phone)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_phone'] = $receiver_phone;

        return $this;
    }

    /**
     * Gets receiver_email
     *
     * @return string|null
     */
    public function getReceiverEmail()
    {
        return $this->container['receiver_email'];
    }

    /**
     * Sets receiver_email
     *
     * @param string|null $receiver_email e-mail получателя
     *
     * @return $this
     */
    public function setReceiverEmail($receiver_email)
    {

        if (is_null($receiver_email)) {
            array_push($this->openAPINullablesSetToNull, 'receiver_email');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('receiver_email', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['receiver_email'] = $receiver_email;

        return $this;
    }

    /**
     * Gets is_problem
     *
     * @return bool|null
     */
    public function getIsProblem()
    {
        return $this->container['is_problem'];
    }

    /**
     * Sets is_problem
     *
     * @param bool|null $is_problem флаг, что заказ проблемный
     *
     * @return $this
     */
    public function setIsProblem($is_problem)
    {

        if (is_null($is_problem)) {
            array_push($this->openAPINullablesSetToNull, 'is_problem');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_problem', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_problem'] = $is_problem;

        return $this;
    }

    /**
     * Gets problem_comment
     *
     * @return string|null
     */
    public function getProblemComment()
    {
        return $this->container['problem_comment'];
    }

    /**
     * Sets problem_comment
     *
     * @param string|null $problem_comment последнее сообщение продавца о проблеме со сборкой
     *
     * @return $this
     */
    public function setProblemComment($problem_comment)
    {

        if (is_null($problem_comment)) {
            array_push($this->openAPINullablesSetToNull, 'problem_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('problem_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['problem_comment'] = $problem_comment;

        return $this;
    }

    /**
     * Gets delivery_service
     *
     * @return int|null
     */
    public function getDeliveryService()
    {
        return $this->container['delivery_service'];
    }

    /**
     * Sets delivery_service
     *
     * @param int|null $delivery_service служба доставки
     *
     * @return $this
     */
    public function setDeliveryService($delivery_service)
    {


        /*if (is_null($delivery_service)) {
            throw new \InvalidArgumentException('non-nullable delivery_service cannot be null');
        }*/
        $this->container['delivery_service'] = $delivery_service;

        return $this;
    }

    /**
     * Gets delivery_method
     *
     * @return int|null
     */
    public function getDeliveryMethod()
    {
        return $this->container['delivery_method'];
    }

    /**
     * Sets delivery_method
     *
     * @param int|null $delivery_method метод доставки
     *
     * @return $this
     */
    public function setDeliveryMethod($delivery_method)
    {


        /*if (is_null($delivery_method)) {
            throw new \InvalidArgumentException('non-nullable delivery_method cannot be null');
        }*/
        $this->container['delivery_method'] = $delivery_method;

        return $this;
    }

    /**
     * Gets delivery_cost
     *
     * @return int|null
     */
    public function getDeliveryCost()
    {
        return $this->container['delivery_cost'];
    }

    /**
     * Sets delivery_cost
     *
     * @param int|null $delivery_cost стоимость доставки (без учета скидки) в копейках
     *
     * @return $this
     */
    public function setDeliveryCost($delivery_cost)
    {


        /*if (is_null($delivery_cost)) {
            throw new \InvalidArgumentException('non-nullable delivery_cost cannot be null');
        }*/
        $this->container['delivery_cost'] = $delivery_cost;

        return $this;
    }

    /**
     * Gets delivery_price
     *
     * @return int|null
     */
    public function getDeliveryPrice()
    {
        return $this->container['delivery_price'];
    }

    /**
     * Sets delivery_price
     *
     * @param int|null $delivery_price стоимость доставки (с учетом скидки) в копейках
     *
     * @return $this
     */
    public function setDeliveryPrice($delivery_price)
    {


        /*if (is_null($delivery_price)) {
            throw new \InvalidArgumentException('non-nullable delivery_price cannot be null');
        }*/
        $this->container['delivery_price'] = $delivery_price;

        return $this;
    }

    /**
     * Gets delivery_point_id
     *
     * @return int|null
     */
    public function getDeliveryPointId()
    {
        return $this->container['delivery_point_id'];
    }

    /**
     * Sets delivery_point_id
     *
     * @param int|null $delivery_point_id ID пункта самовывоза из сервиса логистики
     *
     * @return $this
     */
    public function setDeliveryPointId($delivery_point_id)
    {

        if (is_null($delivery_point_id)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_point_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_point_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_point_id'] = $delivery_point_id;

        return $this;
    }

    /**
     * Gets delivery_address
     *
     * @return \Ensi\OmsClient\Dto\Address|null
     */
    public function getDeliveryAddress()
    {
        return $this->container['delivery_address'];
    }

    /**
     * Sets delivery_address
     *
     * @param \Ensi\OmsClient\Dto\Address|null $delivery_address delivery_address
     *
     * @return $this
     */
    public function setDeliveryAddress($delivery_address)
    {

        if (is_null($delivery_address)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_address'] = $delivery_address;

        return $this;
    }

    /**
     * Gets delivery_comment
     *
     * @return string|null
     */
    public function getDeliveryComment()
    {
        return $this->container['delivery_comment'];
    }

    /**
     * Sets delivery_comment
     *
     * @param string|null $delivery_comment комментарий к доставке
     *
     * @return $this
     */
    public function setDeliveryComment($delivery_comment)
    {

        if (is_null($delivery_comment)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_comment'] = $delivery_comment;

        return $this;
    }

    /**
     * Gets items
     *
     * @return \Ensi\OmsClient\Dto\OrderItem[]|null
     */
    public function getItems()
    {
        return $this->container['items'];
    }

    /**
     * Sets items
     *
     * @param \Ensi\OmsClient\Dto\OrderItem[]|null $items items
     *
     * @return $this
     */
    public function setItems($items)
    {


        /*if (is_null($items)) {
            throw new \InvalidArgumentException('non-nullable items cannot be null');
        }*/
        $this->container['items'] = $items;

        return $this;
    }

    /**
     * Gets deliveries
     *
     * @return \Ensi\OmsClient\Dto\Delivery[]|null
     */
    public function getDeliveries()
    {
        return $this->container['deliveries'];
    }

    /**
     * Sets deliveries
     *
     * @param \Ensi\OmsClient\Dto\Delivery[]|null $deliveries deliveries
     *
     * @return $this
     */
    public function setDeliveries($deliveries)
    {


        /*if (is_null($deliveries)) {
            throw new \InvalidArgumentException('non-nullable deliveries cannot be null');
        }*/
        $this->container['deliveries'] = $deliveries;

        return $this;
    }

    /**
     * Gets files
     *
     * @return \Ensi\OmsClient\Dto\OrderFile[]|null
     */
    public function getFiles()
    {
        return $this->container['files'];
    }

    /**
     * Sets files
     *
     * @param \Ensi\OmsClient\Dto\OrderFile[]|null $files files
     *
     * @return $this
     */
    public function setFiles($files)
    {


        /*if (is_null($files)) {
            throw new \InvalidArgumentException('non-nullable files cannot be null');
        }*/
        $this->container['files'] = $files;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


